package HT.fx;

import java.io.OutputStream;
import java.time.LocalDate;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.stage.Stage;
import HT.fx.Pelaaja;
import HT.fx.Pelaajat;
import HT.fx.Karkelot;
import HT.fx.SailoException;


/**
 * @author joonatan
 * @version 31.1.2024
 *
 */
public class PadelMainGUIController {
    
    @FXML private TextField testi;
    
    @FXML private CheckBox auto1;

    @FXML private TextField ika1;

    @FXML private TextField sapo1;
    
     @FXML void handleLisaamuokkaaottelu() {
         handleLisaaOttelu(null, "kanat");
    }

    @FXML void handleLisaapelaaja() {
        LisaaTestiPelaajat();
        //handleLisaaPelaaja(null, "kanat");
        //LisaaPelaaja();
        Syotatiedot();
        
        
        
    }
    
    
    



    //=======================
     
    /**
     * karkelon oma karkelo johon tallennetaan pelaajat ja ottelut.
     */
    private static Karkelot karkelo;
    
    /**
     * @param modalityStage -
     * @param oletus -
     * @return controller
     */
    public static String handleLisaaPelaaja(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                LisaaPelaajaGUIController.class.getResource("LisaaPelaajaGUIView.fxml"),
                "Lisää pelaaja", modalityStage, oletus);
    }
    
    /**
     * @param modalityStage -
     * @param oletus -
     * @return controller
     */
    public static String handleLisaaOttelu(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                OtteluIkkunaGUIController.class.getResource("OtteluIkkunaGUIView.fxml"),
                "Lisää pelaaja", modalityStage, oletus);
    }
    
    /**
     * Syöttää pelaajan tiedot tekstikenttään, tällä hetkellä vain yhteen
     */
    private void Syotatiedot() {
       // Pelaaja pelaaja = karkelo.annaPelaaja(0);
        
        testi.setText(karkelo.annaPelaaja(0).getNimi());
        ika1.setText(String.valueOf(karkelo.annaPelaaja(0).getIka()));
        sapo1.setText(karkelo.annaPelaaja(0).getSahkoposti());
        auto1.setSelected(karkelo.annaPelaaja(0).getAuto());   
    }
    
    /**
     * @param karkelo karkelo jota käytetään tässä käyttöliittymässä
     */
    public void setKarkelo(Karkelot karkelo) {
        PadelMainGUIController.karkelo = karkelo;
        //naytaJasen();
    }


    /*
    private void LisaaPelaaja() {
        Pelaaja uusi = new Pelaaja();
        uusi.rekisteroi();
        uusi.vastaaAkuAnkka();
        try {
            karkelo.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden luomisessa " + e.getMessage());
            return;
        }
        
        //hae(uusi.getTunnusNro());

    }
    */
    
    /**
     * rekisteröi ja lisää parametrina annetun uuden pelaajan
     * @param uusi pelaaja
     */
    public static void LisaaPelaaja(Pelaaja uusi) {
        
        uusi.rekisteroi();
        //uusi.vastaaAkuAnkka();
        try {
            karkelo.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden luomisessa " + e.getMessage());
            return;
        }
        
        //hae(uusi.getTunnusNro());

    }
    
    /**
     * rekisteröi ja lisää parametrina annetun uuden ottelun
     * @param uusi ottelu
     */
    public static void LisaaOttelu(Ottelu uusi) {
        
        uusi.rekisteroi();
        karkelo.lisaa(uusi);
    }
    
    /**
     * Lisää kahdeksan testipelaajaa
     */
    public static void LisaaTestiPelaajat() {
        Pelaaja uusi = new Pelaaja("Rasse", LocalDate.of(1999, 5, 13) , "Rasse@gmail.com", false);
        Pelaaja uusi2 = new Pelaaja("Tuomas", LocalDate.of(2001, 9, 14) , "Tuomas@gmail.com", false);
        Pelaaja uusi3 = new Pelaaja("Joonatan", LocalDate.of(1998, 2, 24) , "Joonatan@gmail.com", true);
        Pelaaja uusi4 = new Pelaaja("Pepe", LocalDate.of(1998, 5, 13) , "Pepe@gmail.com", true);
        Pelaaja uusi5 = new Pelaaja("Levy", LocalDate.of(1999, 5, 13) , "Levy@gmail.com", false);
        Pelaaja uusi6 = new Pelaaja("Robbe", LocalDate.of(1998, 3, 14) , "Robbe@gmail.com", true);
        Pelaaja uusi7 = new Pelaaja("Riku", LocalDate.of(1998, 2, 24) , "Riku@gmail.com", true);
        Pelaaja uusi8 = new Pelaaja("Tommi", LocalDate.of(1998, 5, 13) , "Tommi@gmail.com", true);
        
        LisaaPelaaja(uusi);
        LisaaPelaaja(uusi2);
        LisaaPelaaja(uusi3);
        LisaaPelaaja(uusi4);
        LisaaPelaaja(uusi5);
        LisaaPelaaja(uusi6);
        LisaaPelaaja(uusi7);
        LisaaPelaaja(uusi8);
    }

    /**
     * Palauttaa controllerin käyttämän karkelon jotta sitä voi käyttää muissa controllereissa
     * @return karkelo
     */
    public static Karkelot getKarkelo() {
        return karkelo;
    }

}